'**********************************************************************
'Project : Demo program on how to access an I2CIO expander. Micro128
'Company : Micromint, Inc.
'
'**********************************************************************

$regfile = "m128def.dat"
$baud1 = 9600


'Configure the serial port.
Config Com2 = Dummy , Synchrone = 0 , Parity = None , Stopbits = 1 , Databits = 8 , Clockpol = 0
'Configure PORTD.6 as an ouput and the rest of the port as inputs.
Ddrd = 64


'Open the serial port
Open "com2:" For Random As #1

Dim B As Byte
'The data sent over the I2C bus must be loacted at $HFFD in order for the utilities to work.
Dim I2cdatatx As Byte At &HFFD
'The Slave Address must be loacted at $HFFB in order for the utilities to work.
Dim Sladdr As Byte At &HFFB
'The Utilities puts the results from a read over the I2C bus at address &HFFE
Dim I2cdatarx As Word At &HFFE
Portd.6 = 1
'A Call to &HFC28 enables the I2C bus to 100kHz.
$asm
  !Call &HFC28;
$end Asm

Do
   Print #1 , "Please enter a number from 0 to 255 and to set the I/O expanders digital I/O."
   Print #1 ,
   Input #1 , B
   Sladdr = &H40
   I2cdatatx = B
   'Call to transmit over the I2C bus
   $asm
     !Call &HFCBD
   $end Asm
   Waitms 200
   Sladdr = &H40
   $asm
     !Call &HFCE2
   $end Asm
   Print #1 , "The digital I/O is set to " ; I2cdatarx ; "."
   Print #1 ,
Loop

Close #1

End

